﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MapSuiteGeocoder;

namespace GeoCoderBug
{
    class Program
    {
        static void Main(string[] args)
        {
            UsaGeocoder usaGeocoder = new UsaGeocoder(@"D:\downloads\heatmap\MapSuiteGeoCoderFullData\MapSuiteGeoCoderFullData\MapSuiteGeoCoderFullData", MatchMode.ExactMatch);

            // Open the geocoder, get any matches and close it
            Collection<GeocoderMatch> geocoderMatches = null;
            try
            {
                usaGeocoder.Open();
                geocoderMatches = usaGeocoder.Match("2014 BENNENT AVE", "75206");
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);    
            }
            finally
            {
                usaGeocoder.Close();
            }

            if (geocoderMatches.Any())
            {
                foreach (GeocoderMatch match in geocoderMatches)
                {
                    WriteKey(match, "Street");
                    WriteKey(match, "City");
                    WriteKey(match, "Zip");
                }                
            }
            else
            {
                Console.WriteLine("No matches.");
            }

            Console.WriteLine("Done.");
            Console.ReadLine();
        }

        static private void WriteKey(GeocoderMatch match, string key)
        {
            if (match.NameValuePairs.ContainsKey(key))
            {
                Console.WriteLine(match.NameValuePairs[key]);
            }
            else
            {
                Console.WriteLine("No " + key);
            }
        }
    }
}
