﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MapSuiteGeocoder;

namespace GeoCoderBug
{
    class Program
    {
        static void Main(string[] args)
        {
            UsaGeocoder usaGeocoder = new UsaGeocoder(@"D:\downloads\heatmap\MapSuiteGeoCoderFullData\MapSuiteGeoCoderFullData\MapSuiteGeoCoderFullData", MatchMode.ExactMatch);

            Match(usaGeocoder, new string[] { "2014 BENNENT AVE", "DALLAS", "TX" });
            Match(usaGeocoder, new string[] { "2014 BENNENT AVE", "75206" });
            Match(usaGeocoder, new string[] { "75206" });

            Console.WriteLine("Done.");
            Console.ReadLine();
        }

        static private void Match(UsaGeocoder usaGeocoder, string[] address)
        {
            Console.WriteLine("For address");

            foreach (string s in address)
            {
                Console.WriteLine(s);
            }

            Console.WriteLine("Match is");

            // Open the geocoder, get any matches and close it
            Collection<GeocoderMatch> geocoderMatches = null;
            try
            {
                usaGeocoder.Open();
                switch (address.Length)
                {
                    case 1:
                        geocoderMatches = usaGeocoder.Match(address[0]);
                        break;
                    case 2:
                        geocoderMatches = usaGeocoder.Match(address[0], address[1]);
                        break;
                    case 3:
                        geocoderMatches = usaGeocoder.Match(address[0], address[1], address[2]);
                        break;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            finally
            {
                usaGeocoder.Close();
            }

            if (geocoderMatches.Any())
            {
                foreach (GeocoderMatch match in geocoderMatches)
                {
                    WriteKey(match, "Street");
                    WriteKey(match, "City");
                    WriteKey(match, "Zip");
                }
            }
            else
            {
                Console.WriteLine("No matches.");
            }

            
        }

        static private void WriteKey(GeocoderMatch match, string key)
        {
            if (match.NameValuePairs.ContainsKey(key))
            {
                Console.WriteLine(match.NameValuePairs[key]);
            }
            else
            {
                Console.WriteLine("No " + key);
            }
        }
    }
}
